// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * An AC electrical connection point to a piece of conducting equipment. Terminals are connected at
 * physical connection points called connectivity nodes.
 * </pre>
 *
 * Protobuf type {@code commonmodule.Terminal}
 */
public final class Terminal extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.Terminal)
    TerminalOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Terminal.newBuilder() to construct.
  private Terminal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Terminal() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new Terminal();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Terminal_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Terminal_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.Terminal.class, openfmb.commonmodule.Terminal.Builder.class);
  }

  public static final int ACDCTERMINAL_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ACDCTerminal aCDCTerminal_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the aCDCTerminal field is set.
   */
  @java.lang.Override
  public boolean hasACDCTerminal() {
    return aCDCTerminal_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
   * @return The aCDCTerminal.
   */
  @java.lang.Override
  public openfmb.commonmodule.ACDCTerminal getACDCTerminal() {
    return aCDCTerminal_ == null ? openfmb.commonmodule.ACDCTerminal.getDefaultInstance() : aCDCTerminal_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ACDCTerminalOrBuilder getACDCTerminalOrBuilder() {
    return aCDCTerminal_ == null ? openfmb.commonmodule.ACDCTerminal.getDefaultInstance() : aCDCTerminal_;
  }

  public static final int PHASES_FIELD_NUMBER = 2;
  private openfmb.commonmodule.Optional_PhaseCodeKind phases_;
  /**
   * <pre>
   * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
   * or ABCN) shall be assumed.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
   * @return Whether the phases field is set.
   */
  @java.lang.Override
  public boolean hasPhases() {
    return phases_ != null;
  }
  /**
   * <pre>
   * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
   * or ABCN) shall be assumed.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
   * @return The phases.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseCodeKind getPhases() {
    return phases_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phases_;
  }
  /**
   * <pre>
   * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
   * or ABCN) shall be assumed.
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder getPhasesOrBuilder() {
    return phases_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phases_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (aCDCTerminal_ != null) {
      output.writeMessage(1, getACDCTerminal());
    }
    if (phases_ != null) {
      output.writeMessage(2, getPhases());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (aCDCTerminal_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getACDCTerminal());
    }
    if (phases_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getPhases());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.Terminal)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.Terminal other = (openfmb.commonmodule.Terminal) obj;

    if (hasACDCTerminal() != other.hasACDCTerminal()) return false;
    if (hasACDCTerminal()) {
      if (!getACDCTerminal()
          .equals(other.getACDCTerminal())) return false;
    }
    if (hasPhases() != other.hasPhases()) return false;
    if (hasPhases()) {
      if (!getPhases()
          .equals(other.getPhases())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasACDCTerminal()) {
      hash = (37 * hash) + ACDCTERMINAL_FIELD_NUMBER;
      hash = (53 * hash) + getACDCTerminal().hashCode();
    }
    if (hasPhases()) {
      hash = (37 * hash) + PHASES_FIELD_NUMBER;
      hash = (53 * hash) + getPhases().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.Terminal parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Terminal parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Terminal parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.Terminal parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Terminal parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Terminal parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.Terminal prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * An AC electrical connection point to a piece of conducting equipment. Terminals are connected at
   * physical connection points called connectivity nodes.
   * </pre>
   *
   * Protobuf type {@code commonmodule.Terminal}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.Terminal)
      openfmb.commonmodule.TerminalOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Terminal_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Terminal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.Terminal.class, openfmb.commonmodule.Terminal.Builder.class);
    }

    // Construct using openfmb.commonmodule.Terminal.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      aCDCTerminal_ = null;
      if (aCDCTerminalBuilder_ != null) {
        aCDCTerminalBuilder_.dispose();
        aCDCTerminalBuilder_ = null;
      }
      phases_ = null;
      if (phasesBuilder_ != null) {
        phasesBuilder_.dispose();
        phasesBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Terminal_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.Terminal getDefaultInstanceForType() {
      return openfmb.commonmodule.Terminal.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.Terminal build() {
      openfmb.commonmodule.Terminal result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.Terminal buildPartial() {
      openfmb.commonmodule.Terminal result = new openfmb.commonmodule.Terminal(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.Terminal result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.aCDCTerminal_ = aCDCTerminalBuilder_ == null
            ? aCDCTerminal_
            : aCDCTerminalBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.phases_ = phasesBuilder_ == null
            ? phases_
            : phasesBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.Terminal) {
        return mergeFrom((openfmb.commonmodule.Terminal)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.Terminal other) {
      if (other == openfmb.commonmodule.Terminal.getDefaultInstance()) return this;
      if (other.hasACDCTerminal()) {
        mergeACDCTerminal(other.getACDCTerminal());
      }
      if (other.hasPhases()) {
        mergePhases(other.getPhases());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getACDCTerminalFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getPhasesFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ACDCTerminal aCDCTerminal_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ACDCTerminal, openfmb.commonmodule.ACDCTerminal.Builder, openfmb.commonmodule.ACDCTerminalOrBuilder> aCDCTerminalBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the aCDCTerminal field is set.
     */
    public boolean hasACDCTerminal() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     * @return The aCDCTerminal.
     */
    public openfmb.commonmodule.ACDCTerminal getACDCTerminal() {
      if (aCDCTerminalBuilder_ == null) {
        return aCDCTerminal_ == null ? openfmb.commonmodule.ACDCTerminal.getDefaultInstance() : aCDCTerminal_;
      } else {
        return aCDCTerminalBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setACDCTerminal(openfmb.commonmodule.ACDCTerminal value) {
      if (aCDCTerminalBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        aCDCTerminal_ = value;
      } else {
        aCDCTerminalBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setACDCTerminal(
        openfmb.commonmodule.ACDCTerminal.Builder builderForValue) {
      if (aCDCTerminalBuilder_ == null) {
        aCDCTerminal_ = builderForValue.build();
      } else {
        aCDCTerminalBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeACDCTerminal(openfmb.commonmodule.ACDCTerminal value) {
      if (aCDCTerminalBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          aCDCTerminal_ != null &&
          aCDCTerminal_ != openfmb.commonmodule.ACDCTerminal.getDefaultInstance()) {
          getACDCTerminalBuilder().mergeFrom(value);
        } else {
          aCDCTerminal_ = value;
        }
      } else {
        aCDCTerminalBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearACDCTerminal() {
      bitField0_ = (bitField0_ & ~0x00000001);
      aCDCTerminal_ = null;
      if (aCDCTerminalBuilder_ != null) {
        aCDCTerminalBuilder_.dispose();
        aCDCTerminalBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ACDCTerminal.Builder getACDCTerminalBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getACDCTerminalFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ACDCTerminalOrBuilder getACDCTerminalOrBuilder() {
      if (aCDCTerminalBuilder_ != null) {
        return aCDCTerminalBuilder_.getMessageOrBuilder();
      } else {
        return aCDCTerminal_ == null ?
            openfmb.commonmodule.ACDCTerminal.getDefaultInstance() : aCDCTerminal_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ACDCTerminal aCDCTerminal = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ACDCTerminal, openfmb.commonmodule.ACDCTerminal.Builder, openfmb.commonmodule.ACDCTerminalOrBuilder> 
        getACDCTerminalFieldBuilder() {
      if (aCDCTerminalBuilder_ == null) {
        aCDCTerminalBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ACDCTerminal, openfmb.commonmodule.ACDCTerminal.Builder, openfmb.commonmodule.ACDCTerminalOrBuilder>(
                getACDCTerminal(),
                getParentForChildren(),
                isClean());
        aCDCTerminal_ = null;
      }
      return aCDCTerminalBuilder_;
    }

    private openfmb.commonmodule.Optional_PhaseCodeKind phases_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder> phasesBuilder_;
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     * @return Whether the phases field is set.
     */
    public boolean hasPhases() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     * @return The phases.
     */
    public openfmb.commonmodule.Optional_PhaseCodeKind getPhases() {
      if (phasesBuilder_ == null) {
        return phases_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phases_;
      } else {
        return phasesBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    public Builder setPhases(openfmb.commonmodule.Optional_PhaseCodeKind value) {
      if (phasesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phases_ = value;
      } else {
        phasesBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    public Builder setPhases(
        openfmb.commonmodule.Optional_PhaseCodeKind.Builder builderForValue) {
      if (phasesBuilder_ == null) {
        phases_ = builderForValue.build();
      } else {
        phasesBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    public Builder mergePhases(openfmb.commonmodule.Optional_PhaseCodeKind value) {
      if (phasesBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          phases_ != null &&
          phases_ != openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance()) {
          getPhasesBuilder().mergeFrom(value);
        } else {
          phases_ = value;
        }
      } else {
        phasesBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    public Builder clearPhases() {
      bitField0_ = (bitField0_ & ~0x00000002);
      phases_ = null;
      if (phasesBuilder_ != null) {
        phasesBuilder_.dispose();
        phasesBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    public openfmb.commonmodule.Optional_PhaseCodeKind.Builder getPhasesBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getPhasesFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    public openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder getPhasesOrBuilder() {
      if (phasesBuilder_ != null) {
        return phasesBuilder_.getMessageOrBuilder();
      } else {
        return phases_ == null ?
            openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phases_;
      }
    }
    /**
     * <pre>
     * Represents the normal network phasing condition. If the attribute is missing three phases (ABC
     * or ABCN) shall be assumed.
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind phases = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder> 
        getPhasesFieldBuilder() {
      if (phasesBuilder_ == null) {
        phasesBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder>(
                getPhases(),
                getParentForChildren(),
                isClean());
        phases_ = null;
      }
      return phasesBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.Terminal)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.Terminal)
  private static final openfmb.commonmodule.Terminal DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.Terminal();
  }

  public static openfmb.commonmodule.Terminal getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Terminal>
      PARSER = new com.google.protobuf.AbstractParser<Terminal>() {
    @java.lang.Override
    public Terminal parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<Terminal> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Terminal> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.Terminal getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

